#include <amxmodx>
#include <fakemeta>
#include <fun>
#include <cstrike>
#include <hamsandwich>

#define is_valid_player(%1) (1 <= %1 <= 32)

new AK_V_MODEL[] 	= "models/neneugomon/v_golden1_ak47.mdl";
new AK_W_MODEL[]	= "models/neneugomon/w_golden1_ak47.mdl";
new AK_P_MODEL[] 	= "models/neneugomon/p_golden1_ak47.mdl";
new M4A1_V_MODEL[]	= "models/neneugomon/v_golden1_m4a1.mdl";
new M4A1_W_MODEL[]  = "models/neneugomon/w_golden1_ak47.mdl";
new M4A1_P_MODEL[]	= "models/neneugomon/p_golden1_m4a1.mdl";

new bool:g_HasAk[33], bool:g_HasM4[33];

forward shop_weapons(id, num);

public plugin_init()
{
	register_plugin("Golden AK-47 & M4A1", "1.2a", "neygomon");

	register_event("WeapPickup","checkModel","b","1=19");
	register_event("CurWeapon","checkWeapon","be","1=1");
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamagePre", false);
	RegisterHam(Ham_Spawn, "player", "fwHamPlayerSpawnPost", true);
   
}

public fwHamPlayerSpawnPost(id)
	g_HasAk[id] = g_HasM4[id] = false;

public plugin_precache()
{
	precache_model(AK_P_MODEL);
	precache_model(AK_V_MODEL);
	precache_model(AK_W_MODEL);
	precache_model(M4A1_P_MODEL);
	precache_model(M4A1_V_MODEL);
	precache_model(M4A1_W_MODEL);
}

public checkModel(id)
{
	switch(read_data(2))
	{
		case CSW_AK47:
		{
			if(!g_HasAk[id]) return;
			set_pev(id, pev_viewmodel2, AK_V_MODEL);
			set_pev(id, pev_weaponmodel2, AK_W_MODEL);
			set_pev(id, pev_weaponmodel2, AK_P_MODEL);
			
		}	
		case CSW_M4A1:
		{
			if(!g_HasM4[id]) return;
			set_pev(id, pev_viewmodel2, M4A1_V_MODEL);
			set_pev(id, pev_weaponmodel2, M4A1_W_MODEL)
			set_pev(id, pev_weaponmodel2, M4A1_P_MODEL);

		}
	}	
}

public checkWeapon(id)
{
	static weapon; weapon = read_data(2);
	if((weapon == CSW_AK47 && g_HasAk[id]) || (weapon == CSW_M4A1 && g_HasM4[id]))
		checkModel(id);
}

public fw_TakeDamagePre(victim, inflictor, attacker, Float:damage)
{
	if(!is_valid_player(attacker)) return;

	switch(get_user_weapon(attacker))
	{
		case CSW_AK47:
		{
			if(g_HasAk[attacker]) SetHamParamFloat(4, damage * 1.06);
		}
		case CSW_M4A1:
		{
			if(g_HasM4[attacker]) SetHamParamFloat(4, damage * 1.06);
		}
	}
}

public shop_weapons(id, num)
{
	switch(num)
	{
		case 1:
		{
			give_item(id, "weapon_ak47");
			cs_set_user_bpammo(id, CSW_AK47, 90);
			g_HasAk[id] = true;
		}
		case 2:
		{
			give_item(id, "weapon_m4a1");
			cs_set_user_bpammo(id, CSW_M4A1, 90);
			g_HasM4[id] = true;
		}
	}	
}